#ifndef PROCESS_H
#define PROCESS_H

#include "PageTable.h"

class Process {
public:
    std::vector<PTE> page_table;
    std::vector<unsigned int> working_set;
    unsigned int execution_time, elapsed_time, id;
    Process *next, *prev;

    Process(unsigned int id, std::vector<PTE> page_table, unsigned int working_set_size, unsigned int execution_time);
    [[nodiscard]] bool is_finished() const;
};



#endif //PROCESS_H
